# This file is part of the Juju GUI, which lets users view and manage Juju
# environments within a graphical interface (https://launchpad.net/juju-gui).
# Copyright (C) 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License version 3, as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranties of MERCHANTABILITY,
# SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""Juju Quickstart base application functions."""


class ProgramExit(Exception):
    """An error occurred while setting up the Juju environment.

    Raise this exception if you want the program to exit gracefully printing
    the error message to stderr.
    """

    def __init__(self, message):
        self.message = message

    def __str__(self):
        return 'juju-quickstart: error: {}'.format(self.message)


def bootstrap(env_name):
    """Bootstrap the Juju environment with the given name.

    Return the environment API address (e.g. "api.example.com:17070").
    Raise a ProgramExit if any error occurs in the bootstrap process.
    Otherwise return when the environment is bootstrapped and the API server
    is ready to accept connections.
    """
    # TODO: everything!
